"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var testing_1 = require("./testing");
var utils_1 = require("./utils");
var connection_1 = require("./connection");
var db_1 = require("./db");
var TestDatabase = /** @class */ (function () {
    function TestDatabase(options) {
        if (options === void 0) { options = {}; }
        this.options = options;
        // this.dbs = [];
    }
    TestDatabase.prototype.init = function (extensions) {
        if (extensions === void 0) { extensions = []; }
        return __awaiter(this, void 0, void 0, function () {
            var _a, config, templatedb, connectionParameters;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!process.env.PGTEMPLATE_DATABASE) {
                            throw new Error('no PGTEMPLATE_DATABASE defined in env!');
                        }
                        _a = this;
                        return [4 /*yield*/, testing_1.getOpts(this.options)];
                    case 1:
                        _a.config = _b.sent();
                        if (!!this.config.template) return [3 /*break*/, 4];
                        config = __assign({}, this.config, { extensions: extensions });
                        return [4 /*yield*/, testing_1.getConnection(config, process.env.PGTEMPLATE_DATABASE)];
                    case 2:
                        templatedb = _b.sent();
                        connection_1.close(templatedb);
                        connectionParameters = templatedb.client.connectionParameters;
                        this.templateConfig = connectionParameters;
                        return [4 /*yield*/, utils_1.setTemplate(this.config, this.templateConfig.database)];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    TestDatabase.prototype.getConnection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var db;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, testing_1.getConnection(__assign({}, this.config, { template: this.templateConfig.database }))];
                    case 1:
                        db = _a.sent();
                        // this.dbs.push(db);
                        return [2 /*return*/, db];
                }
            });
        });
    };
    TestDatabase.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, db_1.dropdb(this.templateConfig)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return TestDatabase;
}());
exports.TestDatabase = TestDatabase;
//# sourceMappingURL=skitch-test.js.map